`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module add2_2x2x_test_S;
  add2_2x2x instance0 (.S(S), .A(A), .B(B), .CIN(CIN));
  add2_2x2x_stim_S instance1 (.S(S), .A(A), .B(B), .CIN(CIN));
endmodule

module add2_2x2x_stim_S(A,B,CIN,S);
    
    output A, B, CIN;
    reg A, B, CIN;
    input S;

    reg [0:3]      vectors[0:8];
    reg [0:3]      ivector;
    integer i_S;

    // Verify functionality of S
    initial begin
      vectors[0] = 4'b0000;
      vectors[1] = 4'b0011;
      vectors[2] = 4'b0101;
      vectors[3] = 4'b0110;
      vectors[4] = 4'b1001;
      vectors[5] = 4'b1010;
      vectors[6] = 4'b1100;
      vectors[7] = 4'b1111;
      
//apply vectors
      for(i_S=0; i_S < 8; i_S = i_S + 1)
      begin
        ivector = vectors[i_S];
        {A,B,CIN} = ivector[0:2];
        #10.00;
        if( ivector[3] !== S)
        $display("verify ERROR:S output mismatch at vector no. %d, %b != %b", i_S, ivector[3], S);
      end
    end


endmodule

