`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module addh2_3x3x_test_COUT;
  addh2_3x3x instance0 (.COUT(COUT), .B(B), .A(A));
  addh2_3x3x_stim_COUT instance1 (.COUT(COUT), .B(B), .A(A));
endmodule

module addh2_3x3x_stim_COUT(B,A,COUT);
    
    output B, A;
    reg B, A;
    input COUT;

    reg [0:2]      vectors[0:4];
    reg [0:2]      ivector;
    integer i_COUT;

    // Verify functionality of COUT
    initial begin
      vectors[0] = 3'b000;
      vectors[1] = 3'b010;
      vectors[2] = 3'b100;
      vectors[3] = 3'b111;
      
//apply vectors
      for(i_COUT=0; i_COUT < 4; i_COUT = i_COUT + 1)
      begin
        ivector = vectors[i_COUT];
        {B,A} = ivector[0:1];
        #10.00;
        if( ivector[2] !== COUT)
        $display("verify ERROR:COUT output mismatch at vector no. %d, %b != %b", i_COUT, ivector[2], COUT);
      end
    end


endmodule

