`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module and2_6x_test_Y;
  and2_6x instance0 (.Y(Y), .B(B), .A(A));
  and2_6x_stim_Y instance1 (.Y(Y), .B(B), .A(A));
endmodule

module and2_6x_stim_Y(B,A,Y);
    
    output B, A;
    reg B, A;
    input Y;

    reg [0:2]      vectors[0:4];
    reg [0:2]      ivector;
    integer i_Y;

    // Verify functionality of Y
    initial begin
      vectors[0] = 3'b000;
      vectors[1] = 3'b010;
      vectors[2] = 3'b100;
      vectors[3] = 3'b111;
      
//apply vectors
      for(i_Y=0; i_Y < 4; i_Y = i_Y + 1)
      begin
        ivector = vectors[i_Y];
        {B,A} = ivector[0:1];
        #10.00;
        if( ivector[2] !== Y)
        $display("verify ERROR:Y output mismatch at vector no. %d, %b != %b", i_Y, ivector[2], Y);
      end
    end


endmodule

