`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module aoi21_2x_test_Y;
  aoi21_2x instance0 (.Y(Y), .C(C), .B(B), .A(A));
  aoi21_2x_stim_Y instance1 (.Y(Y), .C(C), .B(B), .A(A));
endmodule

module aoi21_2x_stim_Y(C,B,A,Y);
    
    output C, B, A;
    reg C, B, A;
    input Y;

    reg [0:3]      vectors[0:8];
    reg [0:3]      ivector;
    integer i_Y;

    // Verify functionality of Y
    initial begin
      vectors[0] = 4'b0001;
      vectors[1] = 4'b0011;
      vectors[2] = 4'b0101;
      vectors[3] = 4'b0110;
      vectors[4] = 4'b1000;
      vectors[5] = 4'b1010;
      vectors[6] = 4'b1100;
      vectors[7] = 4'b1110;
      
//apply vectors
      for(i_Y=0; i_Y < 8; i_Y = i_Y + 1)
      begin
        ivector = vectors[i_Y];
        {C,B,A} = ivector[0:2];
        #10.00;
        if( ivector[3] !== Y)
        $display("verify ERROR:Y output mismatch at vector no. %d, %b != %b", i_Y, ivector[3], Y);
      end
    end


endmodule

