`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

`celldefine
module latch_2x ( D, CLK, Q );
  input D, CLK;
  output Q;
  wire SMC_EN_IN;
  wire SMC_LD_IN;

    wire SMC_CLEAR_IN;
    wire SMC_PRESET_IN;
    buf I0(SMC_EN_IN, CLK);

    buf I1(SMC_LD_IN, D);

        assign SMC_CLEAR_IN = `VCC;
        assign SMC_PRESET_IN =`VCC;
    not I2(SMC_IQN, SMC_IQ);

    ldlatch_p0 I3(.q(SMC_IQ), .d(SMC_LD_IN), .en(SMC_EN_IN), 
          .clear(SMC_CLEAR_IN), .preset(SMC_PRESET_IN));

    //  output pins

    buf I4(Q, SMC_IQ);
endmodule     // latch_2x //
`endcelldefine

