`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

// Testing non inverting pin functionality for Q
module latch_2x_test_Q;
  latch_2x instance0 (.Q(Q), .CLK(CLK), .D(D));
  latch_2x_stim_Q instance1 (.Q(Q), .CLK(CLK), .D(D));
endmodule

module latch_2x_stim_Q(CLK,D,Q);
    
    output CLK, D;
    wire CLK, D;
    input Q;
      integer  i_Q;
      // data test vectors
      reg [0:1] data_vectors[0:1];
      reg [0:1] data_vector;
      assign {D} = data_vector[0];

      // enable test vectors
      reg [0:1] enable_vectors[0:1];
      reg [0:1] enable_vector;
      assign {CLK} = enable_vector[0];


initial begin

//set up for enable and state verification

      data_vector[0] = 1'b0;
        enable_vector[0] = 1'b1;
      #10  $display("initialized state to 0\n");
        enable_vector[0] = 1'b0;
      #10  data_vector[0] = 1'b1 ;

// Enable truth tables

      enable_vectors[0] = 2'b00 ;
      enable_vectors[1] = 2'b11 ;
      
//apply  vectors
      for(i_Q=0; i_Q < 2; i_Q = i_Q + 1)
      begin
        enable_vector = enable_vectors[i_Q];
        #10 ;
        if( enable_vector[1] !== Q)
        $display("verify ERROR:Q output mismatch at enable_vector no. %d, %b != %b", i_Q, enable_vector[1], Q);
        enable_vector[0] = 1'b1;
        data_vector[0] = 1'b0;
        #10         enable_vector[0] = 1'b0;
        #10 data_vector[0] = 1'b1;
      end
// Setting enable vector
      enable_vector[0] = 1'b1;

 //Data truth tables
      data_vectors[0] = 2'b00;
      data_vectors[1] = 2'b11;
      
//apply  vectors
      for(i_Q=0; i_Q < 2; i_Q = i_Q + 1)
      begin
        data_vector = data_vectors[i_Q];
        #10 ;
        enable_vector[0] = 1'b0;
        #10 ;
        if( data_vector[1] !== Q)
        $display("verify ERROR:Q output mismatch at data_vector no. %d, %b != %b",
 i_Q, data_vector[1], Q);
        enable_vector[0] = 1'b1;
        #10 ;
      end
    end
endmodule

