`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module mux2_4x_test_Y;
  mux2_4x instance0 (.Y(Y), .IN1(IN1), .SEL(SEL), .IN0(IN0));
  mux2_4x_stim_Y instance1 (.Y(Y), .IN1(IN1), .SEL(SEL), .IN0(IN0));
endmodule

module mux2_4x_stim_Y(IN1,SEL,IN0,Y);
    
    output IN1, SEL, IN0;
    reg IN1, SEL, IN0;
    input Y;

    reg [0:3]      vectors[0:8];
    reg [0:3]      ivector;
    integer i_Y;

    // Verify functionality of Y
    initial begin
      vectors[0] = 4'b0000;
      vectors[1] = 4'b0011;
      vectors[2] = 4'b0100;
      vectors[3] = 4'b0110;
      vectors[4] = 4'b1000;
      vectors[5] = 4'b1011;
      vectors[6] = 4'b1101;
      vectors[7] = 4'b1111;
      
//apply vectors
      for(i_Y=0; i_Y < 8; i_Y = i_Y + 1)
      begin
        ivector = vectors[i_Y];
        {IN1,SEL,IN0} = ivector[0:2];
        #10.00;
        if( ivector[3] !== Y)
        $display("verify ERROR:Y output mismatch at vector no. %d, %b != %b", i_Y, ivector[3], Y);
      end
    end


endmodule

