`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module mux4_6x_test_Y;
  mux4_6x instance0 (.Y(Y), .IN3(IN3), .SEL1(SEL1), .SEL0(SEL0), .IN2(IN2), .IN1(IN1), .IN0(IN0));
  mux4_6x_stim_Y instance1 (.Y(Y), .IN3(IN3), .SEL1(SEL1), .SEL0(SEL0), .IN2(IN2), .IN1(IN1), .IN0(IN0));
endmodule

module mux4_6x_stim_Y(IN3,SEL1,SEL0,IN2,IN1,IN0,Y);
    
    output IN3, SEL1, SEL0, IN2, IN1, IN0;
    reg IN3, SEL1, SEL0, IN2, IN1, IN0;
    input Y;

    reg [0:6]      vectors[0:64];
    reg [0:6]      ivector;
    integer i_Y;

    // Verify functionality of Y
    initial begin
      vectors[0] = 7'b0000000;
      vectors[1] = 7'b0000011;
      vectors[2] = 7'b0000100;
      vectors[3] = 7'b0000111;
      vectors[4] = 7'b0001000;
      vectors[5] = 7'b0001011;
      vectors[6] = 7'b0001100;
      vectors[7] = 7'b0001111;
      vectors[8] = 7'b0010000;
      vectors[9] = 7'b0010010;
      vectors[10] = 7'b0010101;
      vectors[11] = 7'b0010111;
      vectors[12] = 7'b0011000;
      vectors[13] = 7'b0011010;
      vectors[14] = 7'b0011101;
      vectors[15] = 7'b0011111;
      vectors[16] = 7'b0100000;
      vectors[17] = 7'b0100010;
      vectors[18] = 7'b0100100;
      vectors[19] = 7'b0100110;
      vectors[20] = 7'b0101001;
      vectors[21] = 7'b0101011;
      vectors[22] = 7'b0101101;
      vectors[23] = 7'b0101111;
      vectors[24] = 7'b0110000;
      vectors[25] = 7'b0110010;
      vectors[26] = 7'b0110100;
      vectors[27] = 7'b0110110;
      vectors[28] = 7'b0111000;
      vectors[29] = 7'b0111010;
      vectors[30] = 7'b0111100;
      vectors[31] = 7'b0111110;
      vectors[32] = 7'b1000000;
      vectors[33] = 7'b1000011;
      vectors[34] = 7'b1000100;
      vectors[35] = 7'b1000111;
      vectors[36] = 7'b1001000;
      vectors[37] = 7'b1001011;
      vectors[38] = 7'b1001100;
      vectors[39] = 7'b1001111;
      vectors[40] = 7'b1010000;
      vectors[41] = 7'b1010010;
      vectors[42] = 7'b1010101;
      vectors[43] = 7'b1010111;
      vectors[44] = 7'b1011000;
      vectors[45] = 7'b1011010;
      vectors[46] = 7'b1011101;
      vectors[47] = 7'b1011111;
      vectors[48] = 7'b1100000;
      vectors[49] = 7'b1100010;
      vectors[50] = 7'b1100100;
      vectors[51] = 7'b1100110;
      vectors[52] = 7'b1101001;
      vectors[53] = 7'b1101011;
      vectors[54] = 7'b1101101;
      vectors[55] = 7'b1101111;
      vectors[56] = 7'b1110001;
      vectors[57] = 7'b1110011;
      vectors[58] = 7'b1110101;
      vectors[59] = 7'b1110111;
      vectors[60] = 7'b1111001;
      vectors[61] = 7'b1111011;
      vectors[62] = 7'b1111101;
      vectors[63] = 7'b1111111;
      
//apply vectors
      for(i_Y=0; i_Y < 64; i_Y = i_Y + 1)
      begin
        ivector = vectors[i_Y];
        {IN3,SEL1,SEL0,IN2,IN1,IN0} = ivector[0:5];
        #10.00;
        if( ivector[6] !== Y)
        $display("verify ERROR:Y output mismatch at vector no. %d, %b != %b", i_Y, ivector[6], Y);
      end
    end


endmodule

