`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module nand4_1x_test_Y;
  nand4_1x instance0 (.Y(Y), .D(D), .C(C), .B(B), .A(A));
  nand4_1x_stim_Y instance1 (.Y(Y), .D(D), .C(C), .B(B), .A(A));
endmodule

module nand4_1x_stim_Y(D,C,B,A,Y);
    
    output D, C, B, A;
    reg D, C, B, A;
    input Y;

    reg [0:4]      vectors[0:16];
    reg [0:4]      ivector;
    integer i_Y;

    // Verify functionality of Y
    initial begin
      vectors[0] = 5'b00001;
      vectors[1] = 5'b00011;
      vectors[2] = 5'b00101;
      vectors[3] = 5'b00111;
      vectors[4] = 5'b01001;
      vectors[5] = 5'b01011;
      vectors[6] = 5'b01101;
      vectors[7] = 5'b01111;
      vectors[8] = 5'b10001;
      vectors[9] = 5'b10011;
      vectors[10] = 5'b10101;
      vectors[11] = 5'b10111;
      vectors[12] = 5'b11001;
      vectors[13] = 5'b11011;
      vectors[14] = 5'b11101;
      vectors[15] = 5'b11110;
      
//apply vectors
      for(i_Y=0; i_Y < 16; i_Y = i_Y + 1)
      begin
        ivector = vectors[i_Y];
        {D,C,B,A} = ivector[0:3];
        #10.00;
        if( ivector[4] !== Y)
        $display("verify ERROR:Y output mismatch at vector no. %d, %b != %b", i_Y, ivector[4], Y);
      end
    end


endmodule

