`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module oai22_1x_test_Y;
  oai22_1x instance0 (.Y(Y), .B2(B2), .B1(B1), .A2(A2), .A1(A1));
  oai22_1x_stim_Y instance1 (.Y(Y), .B2(B2), .B1(B1), .A2(A2), .A1(A1));
endmodule

module oai22_1x_stim_Y(B2,B1,A2,A1,Y);
    
    output B2, B1, A2, A1;
    reg B2, B1, A2, A1;
    input Y;

    reg [0:4]      vectors[0:16];
    reg [0:4]      ivector;
    integer i_Y;

    // Verify functionality of Y
    initial begin
      vectors[0] = 5'b00001;
      vectors[1] = 5'b00011;
      vectors[2] = 5'b00101;
      vectors[3] = 5'b00111;
      vectors[4] = 5'b01001;
      vectors[5] = 5'b01010;
      vectors[6] = 5'b01100;
      vectors[7] = 5'b01110;
      vectors[8] = 5'b10001;
      vectors[9] = 5'b10010;
      vectors[10] = 5'b10100;
      vectors[11] = 5'b10110;
      vectors[12] = 5'b11001;
      vectors[13] = 5'b11010;
      vectors[14] = 5'b11100;
      vectors[15] = 5'b11110;
      
//apply vectors
      for(i_Y=0; i_Y < 16; i_Y = i_Y + 1)
      begin
        ivector = vectors[i_Y];
        {B2,B1,A2,A1} = ivector[0:3];
        #10.00;
        if( ivector[4] !== Y)
        $display("verify ERROR:Y output mismatch at vector no. %d, %b != %b", i_Y, ivector[4], Y);
      end
    end


endmodule

