`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

`celldefine
module sdff_4x ( D, CLK, SCAN_IN, TEST, Q );
  input D, CLK, SCAN_IN, TEST;
  output Q;
  wire SMC_CK_IN;
  wire SMC_NS_IN;

    wire SMC_CLEAR_IN;
    wire SMC_PRESET_IN;
    assign SMC_CLEAR_IN =`VCC;
    assign SMC_PRESET_IN =`VCC;
    buf I0(SMC_CK_IN, CLK);

    not I1(SMC_IQN, SMC_IQ);
    not I2(SMC_DIS_SCAN, TEST);

    buf I3(SMC_D_EQN, D);

    and I4(SMC_D_DIS, SMC_DIS_SCAN, SMC_D_EQN);
    buf I5(TEST_buf, TEST);
    buf I6(SCAN_IN_buf, SCAN_IN);
    and I7(SMC_D_SCAN, TEST_buf, SCAN_IN_buf);

    or I8(SMC_NS_IN, SMC_D_DIS, SMC_D_SCAN);

    dff_p0 I9(.q(SMC_IQ), .d(SMC_NS_IN), .clk(SMC_CK_IN), .clear(SMC_CLEAR_IN), 
          .preset(SMC_PRESET_IN));

    //  output pins

    buf I10(Q, SMC_IQ);
endmodule     // sdff_4x //
`endcelldefine

