`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

`celldefine
module sdff_c_2x ( D, CLEAR, CLK, SCAN_IN, TEST, Q );
  input D, CLEAR, CLK, SCAN_IN, TEST;
  output Q;
  wire SMC_CK_IN;
  wire SMC_NS_IN;

    wire SMC_CLEAR_IN;
    wire SMC_PRESET_IN;
    not I0(SMC_CLEAR_INV, CLEAR);

    not I1(SMC_CLEAR_IN, SMC_CLEAR_INV);
    assign SMC_PRESET_IN =`VCC;
    buf I2(SMC_CK_IN, CLK);

    not I3(SMC_IQN, SMC_IQ);
    not I4(SMC_DIS_SCAN, TEST);

    buf I5(SMC_D_EQN, D);

    and I6(SMC_D_DIS, SMC_DIS_SCAN, SMC_D_EQN);
    buf I7(TEST_buf, TEST);
    buf I8(SCAN_IN_buf, SCAN_IN);
    and I9(SMC_D_SCAN, TEST_buf, SCAN_IN_buf);

    or I10(SMC_NS_IN, SMC_D_DIS, SMC_D_SCAN);

    dff_p0 I11(.q(SMC_IQ), .d(SMC_NS_IN), .clk(SMC_CK_IN), .clear(SMC_CLEAR_IN), 
          .preset(SMC_PRESET_IN));

    //  output pins

    buf I12(Q, SMC_IQ);
endmodule     // sdff_c_2x //
`endcelldefine

