`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

// Testing non inverting pin functionality for Q
module sdff_c_4x_test_Q;
  sdff_c_4x instance0 (.Q(Q), .SCAN_IN(SCAN_IN), .TEST(TEST), .D(D), .CLEAR(CLEAR), .CLK(CLK));
  sdff_c_4x_stim_Q instance1 (.Q(Q), .SCAN_IN(SCAN_IN), .TEST(TEST), .D(D), .CLEAR(CLEAR), .CLK(CLK));
endmodule

module sdff_c_4x_stim_Q(SCAN_IN,TEST,D,CLEAR,CLK,Q);
    
    output SCAN_IN, TEST, D, CLEAR, CLK;
    wire SCAN_IN, TEST, D, CLEAR, CLK;
    input Q;
      // clear test vectors
      reg [0:1] clear_vectors[0:1];
      reg [0:1] clear_vector;
      assign {CLEAR} = clear_vector[0];

      integer  i_Q;
      assign {TEST} = 1'b0;//Disable Scan

      // data test vectors
      reg [0:1] data_vectors[0:1];
      reg [0:1] data_vector;
      assign {D} = data_vector[0];

      reg CLKLINE;

      assign CLK = CLKLINE;


 initial begin // set up clock
      CLKLINE = 1'b1;
      repeat (100) #5  CLKLINE= ~CLKLINE;
 end

initial begin
      #1;// stagger measurements after clock edges
      data_vector[0] = 1'b1;
      #10 ; //Pump one cycle
//initialized preset vector to inactive

// truth table values
      clear_vectors[0] = 2'b00 ;
      clear_vectors[1] = 2'b11 ;
      
//apply  vectors
      for(i_Q=0; i_Q < 2; i_Q = i_Q + 1)
      begin
        clear_vector = clear_vectors[i_Q];
        #20 ;// pump two cycles
        if( clear_vector[1] !== Q)
        $display("verify ERROR:Q output mismatch at clear_vector (2nd) no. %d, %b != %b", i_Q, clear_vector[1], Q);


      data_vector[0] = 1'b1;
      #10 ; //Pump one cycle
      end
      clear_vector[0] = 1'b1;// disable clear

// Set up for clock and state measurements

      data_vector[0] = 1'b0;
      #10  $display("initialized state to 0\n");
      data_vector[0] = 1'b1;
      #5 //check for opposite edge
      if ( Q == 1)
        $display("verify ERROR:Q data clocks off the wrong edge\n");
 
      #5 ;// Testing Next State function

//Data truth tables
      data_vectors[0] = 2'b00;
      data_vectors[1] = 2'b11;
      
//apply  vectors
      for(i_Q=0; i_Q < 2; i_Q = i_Q + 1)
      begin
        data_vector = data_vectors[i_Q];
        #20  ;//pump data
        if( data_vector[1] !== Q)
        $display("verify ERROR:Q output mismatch at data_vector no. %d, %b != %b",
 i_Q, data_vector[1], Q);
      end
    end
endmodule

