`timescale 100 ns / 1 ns
`define VCC 1
`define VSS 0

module triinv_6x_test_Y;
  triinv_6x instance0 (.Y(Y), .EN(EN), .A(A));
  triinv_6x_stim_Y instance1 (.Y(Y), .EN(EN), .A(A));
endmodule

module triinv_6x_stim_Y(EN,A,Y);
    
    output EN, A;
    reg EN, A;
    input Y;

    reg [0:2]      vectors[0:4];
    reg [0:2]      ivector;
    integer i_Y;

    // Verify functionality of Y
    initial begin
      vectors[0] = 3'b00_Z_;
      vectors[1] = 3'b01_Z_;
      vectors[2] = 3'b101;
      vectors[3] = 3'b110;
      
//apply vectors
      for(i_Y=0; i_Y < 4; i_Y = i_Y + 1)
      begin
        ivector = vectors[i_Y];
        {EN,A} = ivector[0:1];
        #10.00;
        if( ivector[2] !== Y)
        $display("verify ERROR:Y output mismatch at vector no. %d, %b != %b", i_Y, ivector[2], Y);
      end
    end


endmodule

